namespace CCUpdate;

interface

uses System.IO;

type
  ConsoleApp = class
  private
    class property FindArray: Array of String;
    class property ReplaceArray: Array of String;
  public
    class method LoadSettings;
    class method Main(args: Array of String);
  end;

implementation

class method ConsoleApp.Main(args: Array of String);
begin
  LoadSettings;
  Console.Clear;
  Console.WriteLine('Cortex Command Mod Updater 1.0');
  Console.WriteLine('Build 18/19 to 20 automatic conversion utility.');
  Console.WriteLine();
  if (args.Length > 0) then begin
    for each s: String in args do
      if (not s.Contains('Base.rte')) and (Directory.Exists(s)) then
        try
          var temp: Array[0..1] of Object := CortexCommand.UpdateModule(s.Substring(s.LastIndexOf('\')+1), FindArray, ReplaceArray);
          if Boolean(temp[0]) = false then
            Console.WriteLine('Error: {0}', String(temp[1]))
          else
            Console.WriteLine(String(temp[1]));
        except
          on e: Exception do
            Console.WriteLine(e.Message);
        end;
  end else begin
    var which: String := '';
    Console.WriteLine('Availible modules:');
    for each s: String in CortexCommand.GetModules do
      Console.Write(#9+s.Substring(s.LastIndexOf('\')+1));
    repeat
      Console.WriteLine;
      Console.Write('Convert which module?  ');
      which := Console.ReadLine;
      if Directory.Exists(CortexCommand.CortexDirectory+'\'+which) then begin
        var temp: Array[0..1] of Object := CortexCommand.UpdateModule(which, FindArray, ReplaceArray);
        if Boolean(temp[0]) = false then
          Console.WriteLine('Error: {0}', String(Temp[1]))
        else
          Console.WriteLine(String(Temp[1]));
      end;
    until (which = '') or (which.ToLower in ['quit', 'exit']);
  end;
  Console.Write('Any key to quit...');
  while Console.KeyAvailable = false do
    System.Threading.Thread.Sleep(100);
end;

class method ConsoleApp.LoadSettings; 
var lines: Array of String;
begin
  try
    lines := File.ReadAllLines('.\update.txt');
    FindArray := new String[lines.Length];
    ReplaceArray := new String[lines.Length];
    for i: Int32 := 0 to Lines.Length-1 do begin
      var temp: Array of String := lines[i].Split('|');
      if temp.Length <> 2 then
        raise new Exception(String.Format('Invalid line: {0}', [lines[i]]));
      FindArray[i]    := temp[0];
      ReplaceArray[i] := temp[1];
    end;
    if FindArray.Length = 0 then
      raise new Exception('Fatal error!  Zero-length array returned.');
  except
    on e: Exception do
      Console.WriteLine(String.Format('Error: {0}', e.Message));
  finally
    Array.Clear(lines, 0, lines.Length);
  end;
end;

end.